/****************************************************
* COKE MACHINE SIMULATION WITH AUTOMATA THEORY      *
* LINGUAGENS FORMAIS E AUTOMATOS                    *
* Prof.: Jones Oliveira Albuquerque                 *
*                                                   *
* INTEGRANTES:                                      *
* Anderson de Rezende Rocha [undersun@comp.ufla.br] *
* Flvio Luiz Alves         [alves@comp.ufla.br]    *
* Jlio Csar Alves         [jcalves@comp.ufla.br]  *
* Rodrigo Nazar Leite      [canniggia@comp.ufla.br]*
*                                                   *
* Bacharelado em Cincia da Computao              *
* Universidade Federal de Lavras, MG, Brasil        *
****************************************************/

// classe que define um noh de listaS

#ifndef CLNOHLISTA_H
#define CLNOHLISTA_H


template <class TValor>
class clNohLista
// O operador = DEVE estar definido na classe TValor.
{
    public:
        clNohLista();           
        ~clNohLista();          
        clNohLista *Proximo();
        TValor Valor();      
        void CopiarValor(const TValor &v); 
        void Proximo(clNohLista *noh);     
    protected:
        TValor *valor;       
        clNohLista *proximo;  
};

template <class TValor>
clNohLista<TValor>::clNohLista()
{
    valor = NULL;
    proximo = NULL;
}

template <class TValor>
clNohLista<TValor>::~clNohLista()
{
    if (valor != NULL)
        delete valor;
}

template <class TValor>
TValor clNohLista<TValor>::Valor()
{
    return *valor;
}

template <class TValor>
clNohLista<TValor>* clNohLista<TValor>::Proximo()
// retorna o valor do proximo
{
    return proximo;
}

template <class TValor>
void clNohLista<TValor>::Proximo(clNohLista *noh)
// muda o valor do proximo
{
    proximo = noh;
}

template <class TValor>
void clNohLista<TValor>::CopiarValor(const TValor &v)
// muda o valor do noh
{
     if (valor != NULL)
        delete valor;
    valor = new TValor(v);
}

#endif
