/****************************************************
* COKE MACHINE SIMULATION WITH AUTOMATA THEORY      *
* LINGUAGENS FORMAIS E AUTOMATOS                    *
* Prof.: Jones Oliveira Albuquerque                 *
*                                                   *
* INTEGRANTES:                                      *
* Anderson de Rezende Rocha [undersun@comp.ufla.br] *
* Flvio Luiz Alves         [alves@comp.ufla.br]    *
* Jlio Csar Alves         [jcalves@comp.ufla.br]  *
* Rodrigo Nazar Leite      [canniggia@comp.ufla.br]*
*                                                   *
* Bacharelado em Cincia da Computao              *
* Universidade Federal de Lavras, MG, Brasil        *
****************************************************/

// Classe que define o alfabeto, proprio da coke Machine,
// a ser utilizado pelo automato
// O alfabeto eh definido pelas acoes que o usuario pode executar na maquina.
// Por exemplo: inserir R$ 0,25, pedir Macaia-Cola, pedir troco, pegar refrigerante

// Acoes na coke machine
// Constantes que representam as acoes propriamente ditas
enum EAlfabeto{
    R$005 = 5,
    R$010 = 10,
    R$025 = 25,
    R$050 = 50,
    R$100 = 100,
    PEDIR_TROCO = 1,
    PEDIR_MACAIA_COLA = 2,
    PEDIR_ORANJACI = 3,
    PEDIR_INGAINANA = 4,

    PEGAR_REFRIGERANTE = 6,
};

// Classe clSimbolo
class clSimbolo
{
    public:
        // Define um construtor padrao
        clSimbolo() {};
        // Construtor a partir de um outro simbolo
        clSimbolo(EAlfabeto simbolo);
        // Construtor a partir de um inteiro
        clSimbolo(int simbolo);
        // Retorna o simbolo, valor.
        EAlfabeto Valor();
        // Possibilita a atribuicao de um simbolo a outro
        void operator=(EAlfabeto simbolo);
        // Possibilita a atribuicao a um simbolo a partir de um inteiro
        void operator=(int simbolo);
        // Compara dois simbolos quanto  sua igualdade
        bool operator==(clSimbolo &simbol);

    private:
        // Passa um inteiro para um simbolo
        EAlfabeto intToAlfabeto(int simbolo);

        // Guarda o simbolo do alfabeto em especifico
        EAlfabeto valor;
};

// Construtor a partir de um outro simbolo
clSimbolo::clSimbolo(EAlfabeto simbolo)
{
    valor = simbolo;
}

// Construtor a partir de um inteiro
clSimbolo::clSimbolo(int simbolo)
{
    valor = intToAlfabeto(simbolo);
}

// Retorna o valor guardado por este simbolo
EAlfabeto clSimbolo::Valor()
{
    return valor;
}

// Operador de atribuicao de um simbolo a outro
void clSimbolo::operator=(EAlfabeto simbolo)
{
    valor = simbolo;
}

// Possibilita a atribuicao a um simbolo a partir de um inteiro
void clSimbolo::operator=(int simbolo)
{
    operator=(intToAlfabeto(simbolo));
}

// Compara um simbolo com outro quanto ao seu valor
bool clSimbolo::operator==(clSimbolo &simbol)
{
    return (Valor() == simbol.Valor());
}

// Transforma um int em um simbolo do EALFABETO
EAlfabeto clSimbolo::intToAlfabeto(int simbolo)
{
    return static_cast<EAlfabeto>(simbolo);
}

